unit EZEncrypt;

interface

uses SysUtils, Types, Windows;

const
  Chs = '8Gjkp3VhbhcjhnGj68Bnkm89SwYb71';
  Chb = 'hGRedcg8409JYTF765dfKYFgbjTYEZ';
  Nez = 1.872379644;

  function EncryptStr(Text:String):string;
  function EncryptInt(v:integer;Text:String):string;
  function EncryptIntX(v:integer;Text:String):string;
  function EncryptVSN(Text:String):string;

implementation

//------------------------------------------------------------------------------
function EncryptVSN(Text:String):string;
  //---------
  function GetVSN:integer;
  var
    NotUsed:     DWORD;
    VolumeFlags: DWORD;
    VolumeInfo:  array[0..MAX_PATH] of Char;
    VolumeSerialNumber: DWORD;
  begin
    GetVolumeInformation(PChar('C:\'),nil, SizeOf(VolumeInfo), @VolumeSerialNumber, NotUsed, VolumeFlags, nil, 0);
    Result := 0;
    if VolumeInfo[1] = '' then Result := 0;
    if VolumeSerialNumber > 0 then Result := VolumeSerialNumber;
  end;
  //----------
begin
  Result := EncryptInt(GetVSN,Text);
end;
//------------------------------------------------------------------------------
function GetChar(J:integer):char;
type
  TVa = array [0..61] of byte;
const
  Va : TVa =  ($30,$31,$32,$33,$34,$35,$36,$37,$38,$39,$41,$42,$43,$44,$45,$46,$47,$48,$49,$4A,$4B,$4C,$4D,$4E,$4F,$50,$51,$52,$53,$54,$55,$56,$57,$58,$59,$5A,$61,$62,$63,$64,$65,$66,$67,$68,$69,$6A,$6B,$6C,$6D,$6E,$6F,$70,$71,$72,$73,$74,$75,$76,$77,$78,$79,$7A);
begin
  Result := Chr(Va[J mod 61]);
end;
//------------------------------------------------------------------------------
function EncryptStr(Text:String):string;                                           // Encrypt a string. This is a one way encryption; Not intended to be decrypted. Although it might be possible, I have'nt tried
  //--------
  function Protect(V:double):double;
  begin
    Result := 1E-9*Trunc(V*1E9);
  end;
  //--------
  procedure GetNt(var N:double);
  begin
    N := Protect(N*(3.99997-Protect(N)));
  end;
  //--------
  function Init(var E,T:string;N:double):double;
  var
    I : integer;
  begin
    Result := N;
    for i := 0 to 500 do GetNt(Result);
    E := T;
  end;
  //--------
  procedure Upgrade(var N:double;K:integer);
  var
    C : integer;
  begin
    for C := 0 to K do GetNt(N);
  end;
  //--------
  function CharIt(V:integer;N:double):integer;
  begin
    Result := V + Trunc((N-Trunc(N))*1E9)
  end;
  //--------
var
  I,J,K : integer;
  Nt    : double;
  enc   : string;
begin
  Nt := Init(enc,text,Nez);
  for i := 1 to Length(Text) do begin
    GetNt(Nt);
    K := Ord(Text[i]);
    J := CharIt(K,Nt);
    enc[i] := GetChar(J);
    Upgrade(Nt,K);
  end;
  result := enc;
end;
//------------------------------------------------------------------------------
function EncryptIntX(v:integer;Text:String):string;                             // Encrypt an text using an integer with the exception of the round-off. It uses a 1E11 roundoff so the resulting encrypted text is different for every integer ,but it might not be usable across other platforms.
  //--------
  function Smaller(I:integer):double;
  begin
    Result := (I mod 1000000)/1E7;
  end;
  //--------
  function Protect(V:double):double;
  begin
    Result := 1E-9*Trunc(V*1E9);
  end;
  //--------
  procedure GetNt(var N:double);
  begin
    N := Protect(N*(3.99997-Protect(N)));
  end;
  //--------
  function Init(var E,T:string;N:integer):double;
  var
    I : integer;
  begin
    Result := 1.8 + smaller(N);
    for i := 0 to 500 do GetNt(Result);
    E := T;
  end;
  //--------
  procedure Upgrade(var N:double;K:integer);
  var
    C : integer;
  begin
    for C := 0 to K do GetNt(N);
  end;
  //--------
  function CharIt(V:integer;N:double):integer;
  begin
    Result := V + Trunc((N-Trunc(N))*1E9)
  end;
  //--------
var
  I,J,K : integer;
  Nt    : double;
  enc   : string;
begin
  Nt := Init(enc,text,V);
  for i := 1 to Length(Text) do begin
    GetNt(Nt);
    K := Ord(Text[i]);
    J := CharIt(K,Nt);
    enc[i] := GetChar(J);
    Upgrade(Nt,K);
  end;
  result := enc;
end;
//------------------------------------------------------------------------------
function EncryptInt1(v:integer;Text:String):string;
  //--------
  function Smaller(I:integer):double;
  begin
    Result := (I mod 1000000)/1E7;
  end;
  //--------
  function Protect(V:double):double;
  begin
    Result := 1E-9*Trunc(V*1E9);
  end;
  //--------
  procedure GetNt(var N:double);
  begin
    N := Protect(N*(3.99997-Protect(N)));
  end;
  //--------
  function Init(var E,T:string;N:integer):double;
  var
    I : integer;
  begin
    Result := 1.8 + smaller(N);
    for i := 0 to 500 do GetNt(Result);
    E := T;
  end;
  //--------
  procedure Upgrade(var N:double;K:integer);
  var
    C : integer;
  begin
    for C := 0 to K do GetNt(N);
  end;
  //--------
  function CharIt(V:integer;N:double):integer;
  begin
    Result := V + Trunc((N-Trunc(N))*1E9)
  end;
  //--------
var
  I,J,K : integer;
  Nt    : double;
  enc   : string;
begin
  Nt := Init(enc,text,V);
  for i := 1 to Length(Text) do begin
    GetNt(Nt);
    K := Ord(Text[i]);
    J := CharIt(K,Nt);
    enc[i] := GetChar(J);
    Upgrade(Nt,K);
  end;
  result := enc;
end;
//------------------------------------------------------------------------------
function EncryptInt2(v:integer;Text:String):string;
  //--------
  function Smaller(I:integer):double;
  begin
    Result := (I mod 1000000)/1E7;
  end;
  //--------
  function Protect(V:double):double;
  begin
    Result := 1E-9*Trunc(V*1E9);
  end;
  //--------
  procedure GetNt(var N:double);
  begin
    N := Protect(N*(3.99997-Protect(N)));
  end;
  //--------
  function Init(var E,T:string;N:integer):double;
  var
    I : integer;
  begin
    Result := 1.8 + smaller(N);
    for i := 0 to 500 do GetNt(Result);
    E := T;
  end;
  //--------
  procedure Upgrade(var N:double;K:integer);
  var
    C : integer;
  begin
    for C := 0 to K do GetNt(N);
  end;
  //--------
  function CharIt(V:integer;N:double):integer;
  begin
    Result := V + Trunc((N-Trunc(N))*1E9)
  end;
  //--------
var
  I,J,K : integer;
  Nt    : double;
  enc   : string;
begin
  Nt := Init(enc,text,V);
  for i := 1 to Length(Text) do begin
    GetNt(Nt);
    K := Ord(Text[i]);
    J := CharIt(K,Nt);
    enc[i] := GetChar(J);
    Upgrade(Nt,K);
  end;
  result := enc;
end;
//------------------------------------------------------------------------------
function EncryptInt3(v:integer;Text:String):string;
  //--------
  function Smaller(I:integer):double;
  begin
    Result := (I mod 1000000)/1E7;
  end;
  //--------
  function Protect(V:double):double;
  begin
    Result := 1E-9*Trunc(V*1E9);
  end;
  //--------
  procedure GetNt(var N:double);
  begin
    N := Protect(N*(3.99997-Protect(N)));
  end;
  //--------
  function Init(var E,T:string;N:integer):double;
  var
    I : integer;
  begin
    Result := 1.8 + smaller(N);
    for i := 0 to 500 do GetNt(Result);
    E := T;
  end;
  //--------
  procedure Upgrade(var N:double;K:integer);
  var
    C : integer;
  begin
    for C := 0 to K do GetNt(N);
  end;
  //--------
  function CharIt(V:integer;N:double):integer;
  begin
    Result := V + Trunc((N-Trunc(N))*1E9)
  end;
  //--------
var
  I,J,K : integer;
  Nt    : double;
  enc   : string;
begin
  Nt := Init(enc,text,V);
  for i := 1 to Length(Text) do begin
    GetNt(Nt);
    K := Ord(Text[i]);
    J := CharIt(K,Nt);
    enc[i] := GetChar(J);
    Upgrade(Nt,K);
  end;
  result := enc;
end;
//------------------------------------------------------------------------------
function EncryptInt4(v:integer;Text:String):string;
  //--------
  function Smaller(I:integer):double;
  begin
    Result := (I mod 1000000)/1E7;
  end;
  //--------
  function Protect(V:double):double;
  begin
    Result := 1E-9*Trunc(V*1E9);
  end;
  //--------
  procedure GetNt(var N:double);
  begin
    N := Protect(N*(3.99997-Protect(N)));
  end;
  //--------
  function Init(var E,T:string;N:integer):double;
  var
    I : integer;
  begin
    Result := 1.8 + smaller(N);
    for i := 0 to 500 do GetNt(Result);
    E := T;
  end;
  //--------
  procedure Upgrade(var N:double;K:integer);
  var
    C : integer;
  begin
    for C := 0 to K do GetNt(N);
  end;
  //--------
  function CharIt(V:integer;N:double):integer;
  begin
    Result := V + Trunc((N-Trunc(N))*1E9)
  end;
  //--------
var
  I,J,K : integer;
  Nt    : double;
  enc   : string;
begin
  Nt := Init(enc,text,V);
  for i := 1 to Length(Text) do begin
    GetNt(Nt);
    K := Ord(Text[i]);
    J := CharIt(K,Nt);
    enc[i] := GetChar(J);
    Upgrade(Nt,K);
  end;
  result := enc;
end;
//------------------------------------------------------------------------------
function EncryptInt5(v:integer;Text:String):string;
  //--------
  function Smaller(I:integer):double;
  begin
    Result := (I mod 1000000)/1E7;
  end;
  //--------
  function Protect(V:double):double;
  begin
    Result := 1E-9*Trunc(V*1E9);
  end;
  //--------
  procedure GetNt(var N:double);
  begin
    N := Protect(N*(3.99997-Protect(N)));
  end;
  //--------
  function Init(var E,T:string;N:integer):double;
  var
    I : integer;
  begin
    Result := 1.8 + smaller(N);
    for i := 0 to 500 do GetNt(Result);
    E := T;
  end;
  //--------
  procedure Upgrade(var N:double;K:integer);
  var
    C : integer;
  begin
    for C := 0 to K do GetNt(N);
  end;
  //--------
  function CharIt(V:integer;N:double):integer;
  begin
    Result := V + Trunc((N-Trunc(N))*1E9)
  end;
  //--------
var
  I,J,K : integer;
  Nt    : double;
  enc   : string;
begin
  Nt := Init(enc,text,V);
  for i := 1 to Length(Text) do begin
    GetNt(Nt);
    K := Ord(Text[i]);
    J := CharIt(K,Nt);
    enc[i] := GetChar(J);
    Upgrade(Nt,K);
  end;
  result := enc;
end;
//------------------------------------------------------------------------------
function EncryptInt(v:integer;Text:String):string;
var
 C : integer;
begin
  C := Trunc(Time*24*3600*1000) mod 5;
  case C of
    0 : Result := EncryptInt1(v,text);
    1 : Result := EncryptInt2(v,text);
    2 : Result := EncryptInt3(v,text);
    3 : Result := EncryptInt4(v,text);
    4 : Result := EncryptInt5(v,text);
  end;
end;
//------------------------------------------------------------------------------
end.
