unit EZSecCMDp;

interface

uses Windows, SysUtils, Classes, Forms;

const
  Nez = 1.834567895;

type
  TEZParam = record
     Param   : WideString;
     Back    : string;
     OK      : boolean;
     ArrCheck: array [0..30] of string;
     Count   : integer;
     UTime   : double;
  end;

var
  BackCheck  : string;
  CountEnc   : integer;
  Chb        : string;

  function  CheckParam(LP:string;S:boolean):TEZParam;
  procedure AddLog(F,M:string;E:integer;S:boolean);

implementation
////////////////////////////////////////////////////////////////////////////////
procedure AddLog(F,M:string;E:integer;S:boolean);
var
  SL : TStringList;
begin
  if S then begin
    SL := TSTringList.Create;
    if FileExists(F) then SL.LoadFromFile(F);
    case E of
      0  : SL.Add(DateTimeToStr(Now)+' - '+M+' - '+'OK startup');
      1  : SL.Add(DateTimeToStr(Now)+' - '+M+' - '+'No time at startup');
      2  : SL.Add(DateTimeToStr(Now)+' - '+M+' - '+'Random check found error or program just had first run');
      3  : SL.Add(DateTimeToStr(Now)+' - '+M+' - '+'A debugger has been found while disabeling');
      4  : SL.Add(DateTimeToStr(Now)+' - '+M+' - '+'Wrong encrypted timestamp at startup');
      5  : SL.Add(DateTimeToStr(Now)+' - '+M+' - '+'A debugger has been found or the original file has been deleted');
      6  : SL.Add(DateTimeToStr(Now)+' - '+M+' - '+'Check sequence has been alterd');
      7  : SL.Add(DateTimeToStr(Now)+' - '+M+' - '+'A debugger has been found or application has been deleted');
      8  : SL.Add(DateTimeToStr(Now)+' - '+M+' - '+'Original file has been alterd');
      9  : SL.Add(DateTimeToStr(Now)+' - '+M+' - '+'This file has been changed bitwise');
      10 : SL.Add(DateTimeToStr(Now)+' - '+M+' - '+'Registered application');
      11 : SL.Add(DateTimeToStr(Now)+' - '+M+' - '+'A debugger has been found and the timestamp was wrong');
    end;
    SL.SaveToFile(F);
    SL.Free;
  end;
end;

{$WARNINGS OFF}
//------------------------------------------------------------------------------
function IsDebuggerAttached1:boolean;
asm
  mov eax, fs:[$18]
  mov eax, dword ptr [eax + $30]
  mov eax, dword ptr [eax]
  and eax, $00010000
  shr eax, 16
end;
//------------------------------------------------------------------------------
function IsDebuggerAttached2:boolean;
asm
  mov eax, fs:[$18]
  mov eax, dword ptr [eax + $30]
  mov eax, dword ptr [eax]
  and eax, $00010000
  shr eax, 16
end;
//------------------------------------------------------------------------------
function GetChar(J:integer):char;
type
  TVa = array [0..61] of byte;
const
  Va : TVa =  ($30,$31,$32,$33,$34,$35,$36,$37,$38,$39,$41,$42,$43,$44,$45,$46,$47,$48,$49,$4A,$4B,$4C,$4D,$4E,$4F,$50,$51,$52,$53,$54,$55,$56,$57,$58,$59,$5A,$61,$62,$63,$64,$65,$66,$67,$68,$69,$6A,$6B,$6C,$6D,$6E,$6F,$70,$71,$72,$73,$74,$75,$76,$77,$78,$79,$7A);
begin
  Result := Chr(Va[J mod 61]);
end;
//------------------------------------------------------------------------------
function EncryptStr(Text:String):string;                                           // Encrypt a string. This is a one way encryption; Not intended to be decrypted. Although it might be possible, I have'nt tried
  //--------
  function Protect(V:double):double;
  begin
    Result := 1E-9*Trunc(V*1E9);
  end;
  //--------
  procedure GetNt(var N:double);
  begin
    N := Protect(N*(3.99997-Protect(N)));
  end;
  //--------
  function Init(var E,T:string;N:double):double;
  var
    I : integer;
  begin
    Result := N;
    for i := 0 to 500 do GetNt(Result);
    E := T;
  end;
  //--------
  procedure Upgrade(var N:double;K:integer);
  var
    C : integer;
  begin
    for C := 0 to K do GetNt(N);
  end;
  //--------
  function CharIt(V:integer;N:double):integer;
  begin
    Result := V + Trunc((N-Trunc(N))*1E9)
  end;
  //--------
var
  I,J,K : integer;
  Nt    : double;
  enc   : string;
begin
  Nt := Init(enc,text,Nez);
  for i := 1 to Length(Text) do begin
    GetNt(Nt);
    K := Ord(Text[i]);
    J := CharIt(K,Nt);
    enc[i] := GetChar(J);
    Upgrade(Nt,K);
  end;
  result := enc;
end;
//------------------------------------------------------------------------------
function EncryptIntN(V:integer;Text:String):string;
  //----------
  function RotateBits(C: Char; Bits: Integer): Char;
  const
    Tx : array [0..61] of Char = ('0','Q','B','4','5','b','M','a','H','x','2','k','u','F','r','s','8','R','l','m','P','I','X','D','1','A','9','y','U','3','N','z','K','J','W','v','n','o','c','i','j','V','d','T','O','e','q','L','p','7','g','h','Y','Z','w','E','G','6','f','t','S','C');
  begin
    if IsDebuggerAttached1 then Halt;
    Result := Tx[(Ord(C)+Bits) mod 62];
  end;
  //----------
var
  I : integer;
begin
  if (DebugHook <> 0) then Halt;
  BackCheck := EncryptStr(BackCheck);
  Result := '';
  BackCheck := EncryptStr(BackCheck);
  for I := 1 to Length(Text) do Result := Result + RotateBits(Text[I],V+I);
end;
//------------------------------------------------------------------------------
procedure GetArray(var Arr:Array of string);
var
 I : integer;
begin
  Arr[0] := Chb;
  for I := 1 to Length(Arr)-1 do Arr[I] := EncryptStr(Arr[I-1]);
end;
//------------------------------------------------------------------------------
function KeyOK(LP:string;S:boolean):boolean;
  //----------------------
  function GetKey(dif:integer):String;
  var
    T : double;
  begin
    BackCheck := EncryptStr(BackCheck);
    T := (Time)*288+dif;    // every 5 min T will change
    if IsDebuggerAttached2 then Halt;
    Result := EncryptIntN(Trunc(T),Chb);
    if (DebugHook <> 0) then Halt;
  end;
  //----------------------
begin
  if IsDebuggerAttached1 then Halt;
  if (GetKey(0) = ParamStr(1)) or (GetKey(-1) = ParamStr(1)) then result := True
  else begin
    Result := False;
    AddLog(LP,'',4,S);
    Halt;
  end;
  if (DebugHook <> 0) or not ((GetKey(0) = ParamStr(1)) or (GetKey(-1) = ParamStr(1))) then begin AddLog(LP,'',11,S); Halt; end;
end;
//------------------------------------------------------------------------------
procedure GetParam(var Param:WideString);
var
  I : integer;
begin
  Param := '';
  for I := 3 to ParamCount do
    if (ParamStr(I) <> '') then
       Param := Param+' "' +ParamStr(I)+'"';
end;
//------------------------------------------------------------------------------
{$WARNINGS ON}
function CheckParam(LP:string;S:boolean):TEZParam;
const
  //'JT485y0itt6FjgWj7h75v2jJrQtyLm';  // 4,2,5,3,1,7,6 -> Chb = s4+s2+s5+s3+s1+s7+s6
  arrc : array [1..7] of string = ('75v','485y0i','j7h','JT','tt6FjgW','QtyLm','2jJr');
  arri : array [1..7] of byte   = (4,2,5,3,1,7,6);
begin
  Chb := arrc[arri[1]]+arrc[arri[2]]+arrc[arri[3]]+arrc[arri[4]]+arrc[arri[5]]+arrc[arri[6]]+arrc[arri[7]];
  BackCheck := chb;
  if (ParamCount > 1) then with Result do begin
     UTime := StrToFloat(ParamStr(2));
     CountEnc := 0;
     if not KeyOK(LP,S) then Halt;
     GetParam(Param);
     Back := BackCheck;
     Count := CountEnc;
     GetArray(ArrCheck);
  end;
end;
////////////////////////////////////////////////////////////////////////////////
end.
